import csv
import re

# open the file in the write mode
f = open('resultsParsed_40rep_DeviceOnlyVar_2replicas_Std30_RequestDeviceRandom.csv', 'w',newline='')

# create the csv writer
writer = csv.writer(f)
# Header
writer.writerow(['Repetition','Scenario','Alternative','ExecutionTime','CompletionTime','OverallEnergy','MarginalEnergy','CompletionTimeLink','CompletionTimeDevice', 'EnergyOverallLink','EnergyOverallDevice','EnergyMarginalLink','EnergyMarginalDevice'])

nextline= False

with open("40rep_DeviceOnlyVar_2replicas_Std30_RequestDeviceRandom.txt","r") as fi:
	for ln in fi:
	
		if ln.startswith("Repetition"):
			# Get the repetition number
			repetition =[s for s in re.findall(r'\b\d+\b', ln)]
	
		if ln.startswith("Utilization scenario"):
			# Get the scenario number
			number =[s for s in re.findall(r'\b\d+\b', ln)]
	
		if nextline:
			#This is a line with the results for the placement evaluation
			# The results should be in the following order: CompletionTime, OverallEnergy, MarginalEnergy, CompletionTimeLink, CompletionTimeDevice, EnergyOverallLink, EnergyOverallDevice, EnergyMarginalLink, EnergyMarginalDevice
			results=[s for s in re.findall(r'\d+\.\d+', ln)]
			
			if (results):
				
				# Write to the CSV file
				writer.writerow([repetition[0],number[0],alternative,executionTime[0],results[0],results[1],results[2],results[3],results[4],results[5],results[6],results[7],results[8]])
			else:
				# No results because infeasible
				# Write to the CSV file
				writer.writerow([repetition[0],number[0],alternative,executionTime[0],'NA','NA','NA','NA','NA','NA','NA','NA','NA'])
			
			# Reset
			nextline= False
		
		
		if ln.startswith("OVERALL OPT"):
			# Get the scenario number
			alternative ="Overall"
			# Get the value for the execution time
			executionTime=[s for s in re.findall(r'\d+', ln)]
			# Get to the nextline
			nextline=True
		else:
			if ln.startswith("MARGINAL OPT"):
				# Get the scenario number
				alternative ="Marginal"
				# Get the value for the execution time
				executionTime=[s for s in re.findall(r'\d+', ln)]
				# Get to the nextline
				nextline=True
		

# close the file
f.close()