package application;

/**
 * Class represents application links which connect modules together and represent data dependency between them.
 * @author Klervie Toczé
 *
 */
public class AppLink {

	private String source;
	private String destination;
	/**
	 * CPU length (in MIPS) of tuples carried by the application link
	 */
	private double tupleCpuLength;
	/**
	 * Network length (in bytes) of tuples carried by the application link
	 */
	private double tupleNwLength;

	public AppLink(String source, String destination, double tupleCpuLength,
				   double tupleNwLength){
		setSource(source);
		setDestination(destination);
		setTupleNwLength(tupleNwLength);
		setTupleCpuLength(tupleCpuLength);
	}

	public void setSource(String source) {
		this.source = source;
	}
	public String getDestination() {
		return destination;
	}
	public void setDestination(String destination) {
		this.destination = destination;
	}
	public double getTupleCpuLength() {
		return tupleCpuLength;
	}
	public void setTupleCpuLength(double tupleCpuLength) {
		this.tupleCpuLength = tupleCpuLength;
	}
	public double getTupleNwLength() {
		return tupleNwLength;
	}
	public void setTupleNwLength(double tupleNwLength) {
		this.tupleNwLength = tupleNwLength;
	}

	@Override
	public String toString() {
		return "AppLink [source=" + source + ", destination=" + destination
				+ "]";
	}
}
