package application;

import java.util.ArrayList;
import java.util.List;

/**
 * Class holding information about the application request chain and service placement of the different functions
 * @author Klervie Toczé
 *
 */
public class Application {
	
	private String appId;
	//private List<String> functions;
	private List<AppLink> links;
	
	private List<String> requestChain; //The list of components that are part of the request

	public static Application createApplication(String appId){
		return new Application(appId);
	}
	
	/*public void addAppFunction(String functionName) {
		functions.add(functionName);
	}*/
	
	public void addAppLink(String source, String destination, double tupleCPULength,
						   double tupleNwLength){
		AppLink link = new AppLink(source, destination, tupleCPULength,tupleNwLength);
		getLinks().add(link);
	}
	
	public Application(String appId) {
		setAppId(appId);
		//setFunctions(new ArrayList<>());
		setLinks(new ArrayList<>());
	}
	
	public void setAppId(String appId) {
		this.appId = appId;
	}
	//public List<String> getFunctions() {
	//	return functions;
	//}
	/*public void setFunctions(List<String> functions) {
		this.functions = functions;
	}*/

	public List<AppLink> getLinks() {
		return links;
	}
	public void setLinks(List<AppLink> links) {
		this.links = links;
	}

	public void setRequestChain(List<String> requestChain) {
		this.requestChain = requestChain;
	}

	public List<String> getRequestChain() {
		return requestChain;
	}

	//Function to get the network size needed to come to the target function (i.e. on the incoming edge to the target function)
	public Double getTargetFunctionNwSize(String moduleName){
		Double nwLength=0.0;
		for(AppLink link : getLinks()) {
			if (link.getDestination().equals(moduleName)) {
				nwLength = link.getTupleNwLength();
			}
		}
		return nwLength;
	}
	public Double getTargetFunctionCPUSize(String moduleName){
		Double CPUsize=0.0;
		for(AppLink link : getLinks()) {
			if (link.getDestination().equals(moduleName)) {
				CPUsize = link.getTupleCpuLength();
			}
		}
		return CPUsize;
	}
}
