package device;

import system.Location;

import java.util.ArrayList;
import java.util.List;

public class Device {

    protected String deviceType = null;
    public static final String EDGE = "edge"; // edge device used for orchestration or computation

    protected String name;
    protected Location locationInformation;
    protected double mips;
    protected List<String> modulesPlacedOnDevice;

    public Device(String name, String deviceType, double mips) {
        setName(name);
        setDeviceType(deviceType);
        this.mips=mips;
        modulesPlacedOnDevice= new ArrayList<>();
    }

    public String getName() {
        return name;
    }

    public void setName(String name){
        this.name= name;
    }

    public Location getLocationInformation() {
        return this.locationInformation;
    }
    public void setLocationInformation(Location locationInfo) {
        this.locationInformation= locationInfo;
    }

    public void placeModuleOnDevice(String moduleName){
        //For now we can only place one module one time
        if(!modulesPlacedOnDevice.contains(moduleName)){
            modulesPlacedOnDevice.add(moduleName);
        }
    }

    public List<String> getPlacedModulesOnDevice(){
            return modulesPlacedOnDevice;
    }

    protected void setDeviceType(String deviceType) {
        if (deviceType.equals(Device.EDGE))
            this.deviceType = deviceType;
        else
            System.out.println("ERROR Device type is not supported, see Device class");
    }

    public String getDeviceType() {
        return deviceType;
    }

}
