package device;

import utils.Config;

import static java.lang.Math.floor;

public class PiecewiseLinear implements EnergyModel{

    //Power data from Ahvar et al. - Parasilo server
    int[] powerPerCore = new int[]{98,148,161,176,178,180,184,200,208,212,215,217,218,221,230,237,241};
    int[] powerDynPerCore =new int[17];

    public PiecewiseLinear(){
        for (int i=0; i<powerDynPerCore.length;i++){
            powerDynPerCore[i]=powerPerCore[i]-powerPerCore[0];
        }
    }

    @Override
    public Double getDynamicPowerForUtilization(Double utilization) {
        double powerRes=0.0;
        if(utilization>=100.0){
            powerRes=powerDynPerCore[powerDynPerCore.length-1];
        }
        else{
            int j = (int) floor(utilization* Config.DEFAULT_DEVICE_NB_CORES/100);
            powerRes = (powerDynPerCore[j+1]-powerDynPerCore[j])*Config.DEFAULT_DEVICE_NB_CORES*(utilization/100)+((j+1)*powerDynPerCore[j]-j*powerDynPerCore[j+1]);
        }

        return powerRes;
    }
}
