package placement;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Klervie Toczé
 */
public class RequestPlacementOutput {

    List<String> obtainedTour; //output of the placement
    List<String> obtainedTourVisitReason; //output of the placement
    List<String> elementsForTiming; //All links and devices to be timed according to the placement

    private Map<String, String> appFunctionToDevice; //Function mapping to device name according to obtained tour

    public RequestPlacementOutput() {
    }

   public Map<String, String> getAppFunctionToDevice(){
        return this.appFunctionToDevice;
    }

    public List<String> getElementsForTiming() {
        return elementsForTiming;
    }

    public void setObtainedTour(List<String> obtainedTour) {
        this.obtainedTour = obtainedTour; //Note: shallow copy should not be a problem here as we deep copied when exiting the placement class
    }

    public void setObtainedTourVisitReason(List<String> obtainedTourVisitReason) {
        this.obtainedTourVisitReason = obtainedTourVisitReason; //Note: shallow copy should not be a problem here as we deep copied when exiting the placement class
    }

    public void setElementsForTiming(List<String> elementsForTiming){
        this.elementsForTiming=elementsForTiming;
    }

    public void updateAppFunctionToDevice(){
        appFunctionToDevice = new HashMap<>();
        for (int i = 1; i< obtainedTour.size()-1; i++){ //We remove the init and end
            appFunctionToDevice.put(obtainedTourVisitReason.get(i), obtainedTour.get(i));
        }
    }

}
