package utils;

import java.util.Random;

public class NormalDistribution extends Distribution{

	private double mean;
	private double stdDev;
	
	public NormalDistribution(double mean, double stdDev, long seed) {
		setMean(mean);
		setStdDev(stdDev);
		setRandom(new Random(seed));
	}
	
	@Override
	public double getNextValue() {
		return random.nextGaussian()*stdDev + mean;
	}

	public void setMean(double mean) {
		this.mean = mean;
	}

	public void setStdDev(double stdDev) {
		this.stdDev = stdDev;
	}

}
