package utils;

import org.apache.commons.math3.util.Pair;

public class Utils {
	public static Pair<String,String> splitLongFunctionInstanceName(String longName){
		//Right now the assumption is that the two names are separated with a dash
		//OBS: Do not name devices or functions with a dash inside then!
		Pair<String,String> split;
		if(longName.contains("-")){
			String[] parts = longName.split("-");
			split=new Pair<>(parts[0],parts[1]);
		}
		else{
			//The longName is for a start or end, then there is no instance
			split=new Pair<>(longName,"");
		}
		return split;
	}

	public static  Pair<String,String> splitLinkName(String longName){
		//Right now the assumption is that the two names are separated with =>
		//OBS: Do not name devices or functions with => inside then!
		String[] parts = longName.split("=>");
		Pair<String,String> split=new Pair<>(parts[0],parts[1]);
		return split;
	}

	public static boolean isLink(String name){
		//OBS this is hardcoding
		//Right now the assumption is that the two names are separated with =>
		return name.contains("=>");
	}

	public static Pair<String,String> getLinkStartAndEndDevices(String linkName){
		String startDevice;
		String endDevice;
		Pair<String,String> split = splitLinkName(linkName);
		if(split.getKey().equals(START)){
			startDevice=START;
		}else{
			Pair<String,String> split2=splitLongFunctionInstanceName(split.getKey());
			startDevice=split2.getKey();
		}
		if(split.getValue().equals(END)){
			endDevice=END;
		}else{
			Pair<String,String> split2=splitLongFunctionInstanceName(split.getValue());
			endDevice=split2.getKey();
		}
		Pair<String,String> result=new Pair<>(startDevice,endDevice);
		return result;
	}

	public static String getTargetFunction(String linkName){
		String result;
		Pair<String,String> split = splitLinkName(linkName);
		if(split.getValue().equals(END)){
			result=END;
		}else if(split.getValue().equals(START)){
			//Could be self loop
			result=START;
		}		else{
			Pair<String,String> split2=splitLongFunctionInstanceName(split.getValue());
			result=split2.getValue();
		}
		return result;
	}

	public static  String START = "S";
	public static String END = "E";

}
